/**************************************************************************

	ns

	func_rege.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>

#include "script.h"
#include "script_regex.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

//u
typedef struct _REPINFO {
	rege_refer_t *rf;
	char *str;
	struct _REPINFO *next;
} REPINFO;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static void FreeRepInfo(REPINFO *ri);


/******************************************************************************

	_sfunc_regmatch

	̌

******************************************************************************/

int SFUNC _sfunc_regmatch(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	rege_nfa_t *nfa;
	rege_refer_t *rf;
	VALUEINFO *regvi, *tovi = NULL;
	VALUEINFO *vi, *tmpvi;
	char *str, *p, *tmp;
	BOOL op_i = FALSE;
	int rc;
	int i = 0;

	if(param == NULL){
		return -2;
	}

	//K\
	regvi = param;
	if((param = param->next) == NULL){
		return -2;
	}

	//Ώە
	str = GetValueString(param->v);
	if((param = param->next) != NULL){
		//ϐ
		tovi = param->v->vi;
		if((param = param->next) != NULL){
			//IvV
			tmp = GetValueString(param->v);
			for(p = tmp; *p != '\0' && *p != 'i'; p++);
			if(*p == 'i'){
				//啶
				op_i = TRUE;
			}
			mem_free(&tmp);
		}
	}

	if(regvi->nfa != NULL){
		nfa = regvi->nfa;
	}else{
		//K\̃RpC
		p = GetValueString(regvi->v);
		nfa = rege_compile(p);
		mem_free(&p);
	}

	tmpvi = vi = AllocValue();
	vi->next = NULL;

	//̌
	p = str;
	rc = reg_match(nfa, p, &rf, op_i);
	if(rc > 0){
		for(i = 0; i < nfa->rfcnt; i++){
			vi = vi->next = AllocValue();
			if(rf[i].st == NULL || rf[i].en == NULL){
				vi->v->u.Value = alloc_copy("");
			}else{
				vi->v->u.Value = alloc_copy_n(rf[i].st, rf[i].en - rf[i].st + 1);
			}
			vi->v->Type = TYPE_STRING;
		}
	}
	if(tovi != NULL){
		if(tovi->vi != NULL){
			FreeValueList(tovi->vi);
		}
		tovi->vi = tmpvi->next;
	}

	FreeValue(tmpvi);
	mem_free(&str);
	if(regvi->nfa == NULL){
		free_nfa(nfa);
	}

	//}b`߂lɐݒ
	ret->v->u.iValue = (rc > 0) ? 1 : 0;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_regmatchall

	̌

******************************************************************************/

int SFUNC _sfunc_regmatchall(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	rege_nfa_t *nfa;
	rege_refer_t *rf;
	VALUEINFO *regvi, *tovi = NULL;
	VALUEINFO *vi, *tmpvi;
	char *str, *p, *tmp;
	BOOL op_i = FALSE;
	int rc;
	int i = 0;

	if(param == NULL){
		return -2;
	}

	//K\
	regvi = param;
	if((param = param->next) == NULL){
		return -2;
	}

	//Ώە
	str = GetValueString(param->v);
	if((param = param->next) != NULL){
		//ϐ
		tovi = param->v->vi;
		if((param = param->next) != NULL){
			//IvV
			tmp = GetValueString(param->v);
			for(p = tmp; *p != '\0' && *p != 'i'; p++);
			if(*p == 'i'){
				//啶
				op_i = TRUE;
			}
			mem_free(&tmp);
		}
	}

	if(regvi->nfa != NULL){
		nfa = regvi->nfa;
	}else{
		//K\̃RpC
		p = GetValueString(regvi->v);
		nfa = rege_compile(p);
		mem_free(&p);
	}

	tmpvi = vi = AllocValue();

	//̌
	p = str;
	rc = reg_match(nfa, p, &rf, op_i);
	while(rc > 0){
		if(p == rf[0].st && p == rf[0].en){
			if(*(rf[0].en + 1) == '\0'){
				mem_free(&rf);
				break;
			}
			p = rf[0].en + 1;
		}else{
			//}b`zɒǉ
			vi = vi->next = AllocValue();
			vi->v->u.Value = alloc_copy_n(rf[0].st, rf[0].en - rf[0].st + 1);
			vi->v->Type = TYPE_STRING;
			i++;
			p = rf[0].en;
		}
		mem_free(&rf);
		if(nfa->head_flag == TRUE){
			for(; *p != '\0' && *p != '\r' && *p != '\n'; p++);
			for(; *p == '\r' || *p == '\n'; p++);
			if(*p == '\0'){
				break;
			}
		}
		rc = reg_match(nfa, p, &rf, op_i);
	}

	if(tovi != NULL){
		if(tovi->vi != NULL){
			FreeValueList(tovi->vi);
		}
		tovi->vi = tmpvi->next;
	}

	FreeValue(tmpvi);
	mem_free(&str);
	if(regvi->nfa == NULL){
		free_nfa(nfa);
	}

	//}b`߂lɐݒ
	ret->v->u.iValue = i;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	FreeRepInfo

	ủ

******************************************************************************/

static void FreeRepInfo(REPINFO *ri)
{
	if(ri == NULL) return;
	FreeRepInfo(ri->next);

	mem_free(&(ri->rf));
	mem_free(&(ri->str));
	mem_free(&ri);
}


/******************************************************************************

	_sfunc_regreplace

	̒u

******************************************************************************/

int SFUNC _sfunc_regreplace(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	rege_nfa_t *nfa;
	VALUEINFO *regvi;
	REPINFO *ri, rinfo;
	char *str1, *str2;
	char *tmp;
	char *p, *r;
	int i, len;
	int rc;
	BOOL op_i = FALSE;

	if(param == NULL){
		return -2;
	}

	//K\
	regvi = param;
	if((param = param->next) == NULL){
		return -2;
	}

	//u
	str2 = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&str2);
		return -2;
	}

	//Ώە
	str1 = GetValueString(param->v);
	if((param = param->next) != NULL){
		//IvV
		tmp = GetValueString(param->v);
		for(p = tmp; *p != '\0' && *p != 'i'; p++);
		if(*p == 'i'){
			//啶
			op_i = TRUE;
		}
		mem_free(&tmp);
	}

	if(regvi->nfa != NULL){
		nfa = regvi->nfa;
	}else{
		//K\̃RpC
		p = GetValueString(regvi->v);
		nfa = rege_compile(p);
		mem_free(&p);
	}

	ri = &rinfo;
	ZeroMemory(ri, sizeof(REPINFO));

	//̌
	p = str1;
	rc = reg_match(nfa, p, &ri->rf, op_i);
	while(rc > 0){
		if(p == ri->rf[0].st && p == ri->rf[0].en){
			if(*(ri->rf[0].en + 1) == '\0'){
				break;
			}
			p = ri->rf[0].en + 1;
		}else{
			p = ri->rf[0].en;

			ri = ri->next = mem_alloc(sizeof(REPINFO));
			ZeroMemory(ri, sizeof(REPINFO));
		}
		if(nfa->head_flag == TRUE){
			for(; *p != '\0' && *p != '\r' && *p != '\n'; p++);
			for(; *p == '\r' || *p == '\n'; p++);
			if(*p == '\0'){
				break;
			}
		}
		rc = reg_match(nfa, p, &ri->rf, op_i);
	}

	//u̍쐬
	for(ri = &rinfo; ri != NULL; ri = ri->next){
		if(ri->rf == NULL){
			continue;
		}
		len = 0;
		for(p = str2; *p != '\0'; p++){
			if(*p != '\\' || (*(p + 1) < '0' || *(p + 1) > '9')){
				len++;
				continue;
			}
			p++;
			i = *p - '0';
			if(i < nfa->rfcnt && ri->rf[i].st != NULL && ri->rf[i].en != NULL){
				len += ri->rf[i].en - ri->rf[i].st;
			}
		}
		r = ri->str = mem_alloc(sizeof(char) * (len + 1));
		for(p = str2; *p != '\0'; p++){
			if(*p != '\\' || (*(p + 1) < '0' || *(p + 1) > '9')){
				*(r++) = *p;
				continue;
			}
			p++;
			i = *p - '0';
			if(i < nfa->rfcnt && ri->rf[i].st != NULL && ri->rf[i].en != NULL){
				r = str_cpy_n(r, ri->rf[i].st, ri->rf[i].en - ri->rf[i].st + 1);
			}
		}
		*r = '\0';
	}

	//u㕶̍쐬
	p = str1;
	len = 0;
	for(ri = &rinfo; ri != NULL; ri = ri->next){
		if(ri->rf == NULL){
			continue;
		}
		len += ri->rf[0].st - p;
		len += tstrlen(ri->str);
		p = ri->rf[0].en;
	}
	len += tstrlen(p);

	r = tmp = mem_alloc(sizeof(char) * (len + 1));

	p = str1;
	for(ri = &rinfo; ri != NULL; ri = ri->next){
		if(ri->rf == NULL){
			continue;
		}
		r = str_cpy_n(r, p, ri->rf[0].st - p + 1);
		r = str_cpy(r, ri->str);
		p = ri->rf[0].en;
	}
	r = str_cpy(r, p);

	mem_free(&(rinfo.rf));
	mem_free(&(rinfo.str));
	FreeRepInfo(rinfo.next);

	mem_free(&str1);
	mem_free(&str2);
	if(regvi->nfa == NULL){
		free_nfa(nfa);
	}

	//u̕߂lɐݒ
	ret->v->u.Value = tmp;
	ret->v->Type = TYPE_STRING;
	return 0;
}
/* End of source */
