/**************************************************************************

	ns

	script_memory.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	mem_alloc

	obt@m

******************************************************************************/

void *mem_alloc(int size)
{
	return LocalAlloc(LMEM_FIXED, size);
}


/******************************************************************************

	mem_free

	obt@

******************************************************************************/

void mem_free(void **mem)
{
	if(*mem != NULL){
		LocalFree(*mem);
		*mem = NULL;
	}
}


/******************************************************************************

	alloc_copy

	obt@mۂĕRs[

******************************************************************************/

char *alloc_copy(const char *buf)
{
	char *ret;

	if(buf == NULL){
		return NULL;
	}
	ret = (char *)mem_alloc(sizeof(char) * (tstrlen(buf) + 1));
	if(ret != NULL){
		tstrcpy(ret, buf);
	}
	return ret;
}


/******************************************************************************

	alloc_copy_n

	obt@mۂĎw蒷̕Rs[

******************************************************************************/

char *alloc_copy_n(char *buf, int size)
{
	char *ret;

	if(buf == NULL){
		return NULL;
	}
	ret = (char *)mem_alloc(sizeof(char) * (size + 1));
	if(ret != NULL){
		str_cpy_n(ret, buf, size);
	}
	return ret;
}


/******************************************************************************

	alloc_join

	obt@mۂĕA

******************************************************************************/

char *alloc_join(const char *buf1, const char *buf2)
{
	char *ret, *r;

	if(buf2 == NULL){
		return alloc_copy(buf1);
	}
	if(buf1 == NULL){
		return alloc_copy(buf2);
	}
	ret = mem_alloc(sizeof(char) * (tstrlen(buf1) + tstrlen(buf2) + 1));
	if(ret == NULL){
		return NULL;
	}
	r = str_cpy(ret, buf1);
	tstrcpy(r, buf2);
	return ret;
}
/* End of source */
