/**************************************************************************

	ns

	script_regex.h

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

#ifndef SCRIPT_REGEX_H
#define SCRIPT_REGEX_H

/**************************************************************************
	Include Files
**************************************************************************/

/**************************************************************************
	Define
**************************************************************************/

#define REGVARIABLE			//K\ŕϐɑ


/**************************************************************************
	Struct
**************************************************************************/

//NFA Xg
typedef struct nlist {
	int op;
	union {
		char *chr_class;
		int i;
		struct {
			char c1;
			char c2;
		} c;
#ifdef REGVARIABLE
		struct {
			char *st_var;
			char *end_var;
		} v;
#endif
	} u;
	int eps;
	int to;
	struct nlist *next;
} nlist_t;


//NFA 
typedef struct rege_nfa {
	struct nlist **states;
	int entry;
	int exit;
	int nstate;
	int rfcnt;
	BOOL head_flag;
	BOOL tail_flag;
} rege_nfa_t;


//QƃXg
typedef struct rege_refer {
	char *st;
	char *en;
} rege_refer_t;


/**************************************************************************
	Function Prototypes
**************************************************************************/

void free_nfa(rege_nfa_t *nfa);
rege_nfa_t *rege_compile(char *Ptn);
int reg_match(rege_nfa_t *nfa, char *Str, rege_refer_t **rf, BOOL icase);

BOOL reg_match_value(void *ei, rege_nfa_t *nfa, char *Str);

#endif
/* End of source */
