/**************************************************************************

	ns

	script_string.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

#define ToLower(c)				((c >= 'A' && c <= 'Z') ? (c - 'A' + 'a') : c)


/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static int GetStrLen(const char *buf, int len);


/******************************************************************************

	AllocTcharToChar

	mۂ char  char ɕϊ

******************************************************************************/

char *tchar2char(TCHAR *str)
{
#ifdef UNICODE
	char *cchar;
	int len;

	len = WideCharToMultiByte(CP_ACP, 0, str, -1, NULL, 0, NULL, NULL);
	cchar = (char *)mem_alloc(len + 1);
	if(cchar == NULL){
		return NULL;
	}
	WideCharToMultiByte(CP_ACP, 0, str, -1, cchar, len, NULL, NULL);
	return cchar;
#else
	return alloc_copy(str);
#endif
}


/******************************************************************************

	AllocCharToTchar

	mۂ char  char ɕϊ

******************************************************************************/

TCHAR *char2tchar(char *str)
{
#ifdef UNICODE
	TCHAR *tchar;
	int len;

	len = MultiByteToWideChar(CP_ACP, 0, str, -1, NULL, 0);
	tchar = (TCHAR *)mem_alloc(sizeof(TCHAR) * (len + 1));
	if(tchar == NULL){
		return NULL;
	}
	MultiByteToWideChar(CP_ACP, 0, str, -1, tchar, len);
	return tchar;
#else
	return alloc_copy(str);
#endif
}


/******************************************************************************

	str_cpy

	Rs[čŌ̃̕AhXԂ

******************************************************************************/

char *str_cpy(char *ret, const char *buf)
{
	if(buf == NULL){
		*ret = '\0';
		return ret;
	}
	while(*(ret++) = *(buf++));
	ret--;
	return ret;
}


/******************************************************************************

	str_cpy_n

	w肳ꂽ܂ŕRs[

******************************************************************************/

char *str_cpy_n(char *ret, char *buf, int len)
{
	if(buf == NULL || len <= 0){
		*ret = '\0';
		return ret;
	}
	while(--len && (*(ret++) = *(buf++)));
	*ret = '\0';
	if(len != 0) ret--;
	return ret;
}


/******************************************************************************

	GetStrLen

	rp̒̕擾

******************************************************************************/

static int GetStrLen(const char *buf, int len)
{
	int i;

	for(i = 0;i < len;i++){
		if(*buf == '\0'){
			break;
		}
		buf++;
	}
	return i;
}


/******************************************************************************

	str_cmp_n

	Q̕𕶎rs

******************************************************************************/

int str_cmp_n(const char *buf1, const char *buf2, int len)
{
	int i = 0;

	for(; *buf1 == *buf2 && *buf1 != '\0' && i < len; i++, buf1++, buf2++);
	return ((i == len) ? 0 : *buf1 - *buf2);
}


/******************************************************************************

	str_cmp_i

	̑啶ʂȂrs

******************************************************************************/

int str_cmp_i(const char *buf1, const char *buf2)
{
	for(; ToLower(*buf1) == ToLower(*buf2) && *buf1 != '\0'; buf1++, buf2++);
	return ToLower(*buf1) - ToLower(*buf2);
}


/******************************************************************************

	str_cmp_ni

	Q̕啶AʂȂŔrs

******************************************************************************/

int str_cmp_ni(const char *buf1, const char *buf2, int len)
{
	int i = 0;

	for(; ToLower(*buf1) == ToLower(*buf2) && *buf1 != '\0' && i < len; i++, buf1++, buf2++);
	return ((i == len) ? 0 : ToLower(*buf1) - ToLower(*buf2));
}


/******************************************************************************

	str_match

	Q̕ChJ[h(*)gĔrs

******************************************************************************/

BOOL str_match(const char *Ptn, const char *Str)
{
	switch(*Ptn)
	{
	case '\0':
		return (*Str == '\0');
	case '*':
		return str_match(Ptn + 1, Str) || (*Str != '\0') && str_match(Ptn, Str + 1);
	case '?':
		return (*Str != '\0') && str_match(Ptn + 1, Str + 1);
	default:
		return (ToLower(*Ptn) == ToLower(*Str)) && str_match(Ptn + 1, Str + 1);
	}
}


/******************************************************************************

	i2a

	l10i\L̕ɕϊ

******************************************************************************/

static char *ri2a(char *p, long i)
{
    if(i / 10 != 0){
		p = ri2a(p, i / 10);
	}
	i %= 10;
    *(p++) = '0' + (char)((i < 0) ? (i * -1) : i);
	return p;
}
char *i2a(long i)
{
	char *buf;
	char *p, *r;
	long j = i;
	int cnt = 1;

	while((j = j / 10) != 0){
		cnt++;
	}

	p = buf = mem_alloc(sizeof(char) * (cnt + 2));
	if(i < 0){
		*(p++) = '-';
	}
	r = ri2a(p, i);
	*r = '\0';
	return buf;
}


/******************************************************************************

	x2d

	16i\L̕𐔒lɕϊ

******************************************************************************/

long x2d(const char *str)
{
	int num = 0;
	int m;

	for(; *str != '\0'; str++){
		if(*str >= '0' && *str <= '9'){
			m = *str - '0';
		}else if(*str >= 'A' && *str <= 'F'){
			m = *str - 'A' + 10;
		}else if(*str >= 'a' && *str <= 'f'){
			m = *str - 'a' + 10;
		}else{
			break;
		}
		num = 16 * num + m;
	}
	return num;
}


/******************************************************************************

	o2d

	8i\L̕𐔒lɕϊ

******************************************************************************/

long o2d(const char *str)
{
	int num = 0;
	int m;

	for(; *str != '\0'; str++){
		if(*str >= '0' && *str <= '7'){
			m = *str - '0';
		}else{
			break;
		}
		num = 8 * num + m;
	}
	return num;
}


/******************************************************************************

	conv_ctrl

	䕶ϊ

******************************************************************************/

BOOL conv_ctrl(char *buf)
{
	char *p, *r, *s;
	char tmp[10];

	if(buf == NULL){
		return FALSE;
	}

	p = buf;
	while(*p != '\0'){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE && *(p + 1) != '\0'){
			//2oCgR[hXLbv
			p += 2;
			continue;
		}
		if(*p == '\\' && *(p + 1) != '\0'){
			//䕶̕ϊ
			r = p + 1;
			switch(*r)
			{
			case 'r':
				//CR
				r++;
				*(p++) = '\r';
				break;

			case 'n':
				//LF
				r++;
				*(p++) = '\n';
				break;

			case 't':
				//^u
				r++;
				*(p++) = '\t';
				break;

			case 'b':
				//obNXy[X
				r++;
				*(p++) = '\b';
				break;

			case 'x':
				//Char (Hex)
				r++;
				if(*r != '\0'){
					for(s = r; (s - r) < 2 && ((*s >= '0' && *s <= '9')
						|| (*s >= 'A' && *s <= 'F')
						|| (*s >= 'a' && *s <= 'f')); s++);
					str_cpy_n(tmp, r, s - r + 1);
					*(p++) = (unsigned char)x2d(tmp);
					r += s - r;
				}
				break;

			case '\"':
				r++;
				*(p++) = '\"';
				break;

			case '\\':
				r++;
				*(p++) = '\\';
				break;

			default:
				if(*r >= '0' && *r <= '7'){
					//Char (Oct)
					for(s = r; (s - r) < 3 && (*s >= '0' && *s <= '7'); s++);
					str_cpy_n(tmp, r, s - r + 1);
					*(p++) = (char)o2d(tmp);
					r += s - r;
					break;
				}else{
					p++;
				}
				continue;
			}
			tstrcpy(p, r);

		}else{
			p++;
		}
	}
	return TRUE;
}


/******************************************************************************

	str_skip

	̏Iʒu̎擾

******************************************************************************/

char *str_skip(char *p)
{
	//̓XLbv
	for(p++; *p != '\0' && *p != '\"'; p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE && *(p + 1) != '\0'){
			//2oCgR[hXLbv
			p++;
			if(*p == '\0') break;
			continue;
		}
		if(*p == '\\'){
			p++;
			if(*p == '\0'){
				break;
			}
		}
	}
	return p;
}


/******************************************************************************

	GetPairtBrace

	Ή銇ʂ擾

******************************************************************************/

char *get_pair_brace(char *buf)
{
	char sc, ec;
	int k_cnt = 1;

	sc = *buf;
	switch(sc)
	{
	case '{':
		ec = '}';
		break;

	case '(':
		ec = ')';
		break;

	case '[':
		ec = ']';
		break;

	default:
		return NULL;
	}

	for(buf++; *buf != '\0'; buf++){
		if(IsDBCSLeadByte((BYTE)*buf) == TRUE && *(buf + 1) != '\0'){
			//2oCgR[hXLbv
			buf++;
			if(*buf == '\0'){
				break;
			}
			continue;
		}
		if(*buf == '\"'){
			//̓XLbv
			buf = str_skip(buf);
			if(*buf == '\0'){
				break;
			}
		}
		if(*buf == '/' && *(buf + 1) == '/'){
			//RgXLbv
			for(; *buf != '\0' && *buf != '\r' && *buf != '\n'; buf++);
			if(*buf == '\0'){
				break;
			}
		}
		if(*buf == sc){
			k_cnt++;
		}else if(*buf == ec){
			k_cnt--;
		}
		if(k_cnt == 0) break;
	}
	return ((k_cnt == 0) ? buf : NULL);
}


/******************************************************************************

	str_trim

	̑Ő, Tab

******************************************************************************/

BOOL str_trim(char *buf)
{
	char *p, *r;

	//Ő󔒂|C^擾
	for(p = buf; (*p == ' ' || *p == '\t') && *p != '\0'; p++);
	for(r = buf + tstrlen(buf) - 1; (*r == ' ' || *r == '\t') && r > p; r--);
	*(r + 1) = '\0';

	//̕ɃRs[s
	tstrcpy(buf, p);
	return TRUE;
}


/******************************************************************************

	str_lower

	ɕϊ

******************************************************************************/

void str_lower(char *p)
{
	for(; *p != '\0'; p++){
		*p = ToLower(*p);
	}
}


/******************************************************************************

	str2hash

	̃nbVl擾

******************************************************************************/

int str2hash(char *str)
{
	int hash = 0;

	for(; *str != '\0'; str++){
		hash = ((hash << 1) + *str);
	}
	return hash;
}
/* End of source */
